{# Template for CA config file #}
{{ ansible_managed | comment }}

## Root Certificate Authority Internal Issuing Configuration File.

## MAIN ########################################################################

[ openssl_conf_section ]
alg_section = evp_sect

[ evp_sect ]
fips_mode = {{ 'yes' if certificate_authority_config_fips | bool else 'no' }}

[ ca ]
default_ca = inti_ca

## CA ##########################################################################

[ inti_ca ]
dir               = {{ certificate_authority_config_dir }}/g{{ generation }}/inti
certs             = $dir/certs
certificate       = $dir/certs/inti.crt
private_key       = $dir/private/inti.key
new_certs_dir     = $dir/signed
default_days      = {{ certificate_authority_config_inti_signing_validity }}
default_md        = {{ certificate_authority_config_inti_signing_algorithm }}
database          = $dir/data/index
serial            = $dir/data/serial
RANDFILE          = $dir/data/rand
{# crl               = $dir/crl/inti.crl #}
{# crl_dir           = $dir/crl #}
{# default_crl_days  = {{ certificate_authority_config_inti_signing_crl_days }} #}
{# crlnumber         = $dir/data/crl_serial #}
{# crl_extensions    = crl_ext #}
name_opt          = ca_default
cert_opt          = ca_default
preserve          = no
policy            = ca_policy
copy_extensions   = copy

## POLICY ######################################################################

[ ca_policy ]
countryName             = {{ certificate_authority_config_policy_country }}
stateOrProvinceName     = {{ certificate_authority_config_policy_state }}
localityName            = {{ certificate_authority_config_policy_locality }}
organizationName        = {{ certificate_authority_config_policy_organization }}
emailAddress            = {{ certificate_authority_config_policy_email }}
commonName              = supplied

## REQUESTS ####################################################################

[ req ]
default_bits        = {{ certificate_authority_config_inti_signing_key_bits }}
default_md          = {{ certificate_authority_config_inti_signing_algorithm }}
distinguished_name  = req_distinguished_name
string_mask         = utf8only
x509_extensions     = server_cert

[ req_distinguished_name ]
countryName                     = Country Name (2 letter code)
stateOrProvinceName             = State or Province Name
localityName                    = Locality Name
0.organizationName              = Organization Name
commonName                      = Common Name
emailAddress                    = Email Address

countryName_default             = {{ certificate_authority_config_subject_country }}
stateOrProvinceName_default     = {{ certificate_authority_config_subject_state }}
localityName_default            = {{ certificate_authority_config_subject_locality }}
0.organizationName_default      = {{ certificate_authority_config_subject_organization }}
emailAddress_default            = {{ certificate_authority_config_subject_email }}

## X509 CA #####################################################################

[ server_cert ]
basicConstraints = CA:FALSE
nsCertType = server
nsComment = “{{ certificate_authority_config_name | default(certificate_authority_config_subject_organization,true) }} Server Certificate”
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid,issuer:always
keyUsage = critical, digitalSignature, keyEncipherment
extendedKeyUsage = serverAuth

[ usr_cert ]
basicConstraints = CA:FALSE
nsCertType = client, email
nsComment = “{{ certificate_authority_config_name | default(certificate_authority_config_subject_organization,true) }} Client Certificate”
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid,issuer
keyUsage = critical, nonRepudiation, digitalSignature, keyEncipherment
extendedKeyUsage = clientAuth, emailProtection

{#
## CRL & OCSP ##################################################################

[ crl_ext ]
authorityKeyIdentifier=keyid:always
crlDistributionPoints = URI:http://example.com/crl.pem

[ ocsp ]
basicConstraints = CA:FALSE
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid,issuer
keyUsage = critical, digitalSignature
extendedKeyUsage = critical, OCSPSigning
authorityInfoAccess = OCSP;URI:http://ocsp.example.com, CAIssuers;URI:http://example.com/root-ca.pem
#}
